﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CMDSpacePirates
{
    public static class Animation
    {
        public static List<Animator> animators = new List<Animator>();

        public static void PlayMe(GameObject obj, char[][] anim, bool shouldLoop)
        {
            foreach (Animator animator in animators)
            {
                if (animator.obj == obj)
                {
                    animator.curFrame = 0;
                    animator.anim = anim;
                    animator.shouldLoop = shouldLoop;
                    return;
                }
            }

            animators.Add(new Animator(obj, anim, shouldLoop));
        }

        public static void StopMe(GameObject obj)
        {
            foreach (Animator animator in animators)
            {
                if (animator.obj == obj)
                {
                    animators.Remove(animator);
                    return;
                }
            }
        }

        public static void Tick()
        {
            foreach (Animator animator in animators)
            {
                animator.Animate();
            }
        }
    }

    public class Animator
    {
        public GameObject obj;
        public char[][] anim;
        public bool shouldLoop;
        public int curFrame;
        
        int animFrames;

        public Animator(GameObject _obj, char[][] _anim, bool _shouldLoop)
        {
            obj = _obj;
            anim = _anim;
            shouldLoop = _shouldLoop;

            animFrames = anim.GetLength(0) - 1;
            curFrame = 0;
        }

        public void Animate()
        {
            if (curFrame > animFrames)
            {
                if (shouldLoop)
                    curFrame = 0;
                else
                {
                    obj.size = Vector.Zero;
                    obj.graphic = new char[] { ' ' };
                    return;
                }
            }

            for (int i = 0; i < anim[curFrame].Length; i++)
            {
                if (Ship.IsEquipment(obj.graphic[i]) || obj.graphic[i] == 'x')
                {
                    anim[curFrame][i] = obj.graphic[i];
                }
            }

            obj.graphic = anim[curFrame];
            curFrame++;
        }
    }
}
