﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CMDSpacePirates
{
    public static class GameConsole
    {
        static List<string> consoleLines = new List<string>();
        public static int maxConsoleLines = 12;

        public static void RenderConsole()
        {
            for (int i = 0; i < Render.renderSizeX; i++)
            {
                Console.Write("══");
            }

            Console.WriteLine("");
            Console.WriteLine(" POINTS: " + GameManager.points);
            
            foreach (string line in consoleLines)
            {
                Console.WriteLine(line);
            }
        }

        public static void UserInput(string txt)
        {
            if (string.IsNullOrEmpty(txt))
                return;

            Write(txt);

			string[] arguments = txt.Split(new char[] { ' ' }, StringSplitOptions.RemoveEmptyEntries);

			foreach(string s in arguments){
				s.ToLower().Trim();
			}

            switch (arguments[0]) {
                case "test":
                    Write("Test OK!");
                    break;
                case "help":
                    Write("FIRE {X} {Y} - Fires one of your guns at position");
                    Write("BUY {Part} - Buys chosen part");
                    Write("SHOP - Opens the shop");
                    Write("MOVE {Dir} - N, E, S, W, NW, SW, NE, SE");
                    Write("STOP - Stops the ship");
                    Write("GRID - Turns grid ON / OFF");
                    Write("FIND - Finds the nearest enemy");
                    Write("CREDITS - See our beautiful names");
                    Write("EXIT - Exits the game");
                    break;
                case "grid":
                    Render.showGrid = !Render.showGrid;
                    break;
                case "shop":
                    Write("GUN    (g)  Price: " + GameManager.gunPrice);
                    Write("ENGINE (e)  Price: " + GameManager.enginePrice);
                    break;
                case "find":
                    FindEnemy();
                    break;
                case "fire":
                    if (arguments.Length < 3) {
                        Write("Remember to insert coordinates! You fire by saying 'Fire X Y' . . .");
                    } else if (arguments.Length == 3) {
                        if (int.TryParse(arguments[1], out int number1) && int.TryParse(arguments[2], out int number2)) {
                            //Player.Shoot(number1, number2);
                            if (Program.player.AreGunsAvailable) {
                                Program.player.Fire(new Vector(number1, number2));
                                Write("Fire at " + number1 + ", " + number2 + "!");
                            } else {
                                Write("No guns are ready to fire at the moment!");
                            }
                        } else {
                            Write("You have to put in coordinates... That means numbers");
                        }
                    } else {
                        Write("Sorry, couldn't understand that! You fire by saying 'Fire X Y' . . .");
                    }
                    break;
                case "exit":
                    if (arguments.Length == 1)
                        Program.running = false;
                    else
                        Write("Are you trying to quit on me bro!?");
                    break;
                case "credits":
                    GameConsole.Write(" - MADE BY -            ");
                    GameConsole.Write("HJALTE TAGMOSE          ");
                    GameConsole.Write("ASGER GOTVED HVID       ");
                    break;
                case "buy":
                    switch (arguments[1]) {
                        case "g":
                            if (GameManager.points >= GameManager.gunPrice) {
                                if (!Program.player.IsFullyUpgraded) {
                                    Program.player.AddEquipment('g');
                                    GameManager.points -= GameManager.gunPrice;
                                    Write("Gun has been added to ship!");
                                } else
                                    Write("You're already fully upgraded.");
                            } else
                                Write("You don't have enough points.");
                            break;
                        case "e":
                            if (GameManager.points >= GameManager.enginePrice) {
                                if (!Program.player.IsFullyUpgraded) {
                                    Program.player.AddEquipment('e');
                                    GameManager.points -= GameManager.enginePrice;
                                    Write("Engine has been added to ship!");
                                } else
                                    Write("You're already fully upgraded.");
                            } else
                                Write("You don't have enough points.");
                            break;
                        case "gun":
                            if (GameManager.points >= GameManager.gunPrice) {
                                if (!Program.player.IsFullyUpgraded) {
                                    Program.player.AddEquipment('g');
                                    GameManager.points -= GameManager.gunPrice;
                                    Write("Gun has been added to ship!");
                                } else
                                    Write("You're already fully upgraded.");
                            } else
                                Write("You don't have enough points.");
                            break;
                        case "engine":
                            if (GameManager.points >= GameManager.enginePrice) {
                                if (!Program.player.IsFullyUpgraded) {
                                    Program.player.AddEquipment('e');
                                    GameManager.points -= GameManager.enginePrice;
                                    Write("Engine has been added to ship!");
                                } else
                                    Write("You're already fully upgraded.");
                            } else
                                Write("You don't have enough points.");
                            break;
                    }
                    break;
                case "move":
                    if (arguments.Length > 1)
                    {
                        switch (arguments[1])
                        {
                            case "n":
                                Program.player.dir = new Vector(0, 1);
                                Animation.PlayMe(Program.player, Program.player.nAnim, true);
                                break;
                            case "e":
                                Program.player.dir = new Vector(1, 0);
                                Animation.PlayMe(Program.player, Program.player.eAnim, true);
                                break;
                            case "s":
                                Program.player.dir = new Vector(0, -1);
                                Animation.PlayMe(Program.player, Program.player.sAnim, true);
                                break;
                            case "w":
                                Program.player.dir = new Vector(-1, 0);
                                Animation.PlayMe(Program.player, Program.player.wAnim, true);
                                break;
                            case "nw":
                                Program.player.dir = new Vector(-1, 1);
                                Animation.PlayMe(Program.player, Program.player.nwAnim, true);
                                break;
                            case "sw":
                                Program.player.dir = new Vector(-1, -1);
                                Animation.PlayMe(Program.player, Program.player.swAnim, true);
                                break;
                            case "ne":
                                Program.player.dir = new Vector(1, 1);
                                Animation.PlayMe(Program.player, Program.player.neAnim, true);
                                break;
                            case "se":
                                Program.player.dir = new Vector(1, -1);
                                Animation.PlayMe(Program.player, Program.player.seAnim, true);
                                break;
                            case "stop":
                                Program.player.dir = Vector.Zero;
                                Animation.PlayMe(Program.player, Program.player.stopAnim, true);
                                break;
                        }
                    }
					break;
                case "n":
                    Program.player.dir = new Vector(0, 1);
                    Animation.PlayMe(Program.player, Program.player.nAnim, true);
                    break;
                case "e":
                    Program.player.dir = new Vector(1, 0);
                    Animation.PlayMe(Program.player, Program.player.eAnim, true);
                    break;
                case "s":
                    Program.player.dir = new Vector(0, -1);
                    Animation.PlayMe(Program.player, Program.player.sAnim, true);
                    break;
                case "w":
                    Program.player.dir = new Vector(-1, 0);
                    Animation.PlayMe(Program.player, Program.player.wAnim, true);
                    break;
                case "nw":
                    Program.player.dir = new Vector(-1, 1);
                    Animation.PlayMe(Program.player, Program.player.nwAnim, true);
                    break;
                case "sw":
                    Program.player.dir = new Vector(-1, -1);
                    Animation.PlayMe(Program.player, Program.player.swAnim, true);
                    break;
                case "ne":
                    Program.player.dir = new Vector(1, 1);
                    Animation.PlayMe(Program.player, Program.player.neAnim, true);
                    break;
                case "se":
                    Program.player.dir = new Vector(1, -1);
                    Animation.PlayMe(Program.player, Program.player.seAnim, true);
                    break;
                case "stop":
					Program.player.dir = Vector.Zero;
                    Animation.PlayMe(Program.player, Program.player.stopAnim, true);
                    break;
				default:
					Write("Couldn't understand command.");
					break;
            }
        }

        public static void FindEnemy()
        {
            float shortestDistance = 1000000;
            Enemy closest = null;
            foreach(GameObject go in Program.gameObjects)
            {
                if (go is Enemy)
                {
                    if (Vector.Magnitude(Vector.DifferenceWrap(Program.player.pos, go.pos)) < shortestDistance)
                    {
                        shortestDistance = Vector.Magnitude(Vector.DifferenceWrap(Program.player.pos, go.pos));
                        closest = go as Enemy;
                    }
                }
            }
            if (closest != null)
                GameConsole.Write("The closest enemy is at: " + closest.pos.x + ", " + closest.pos.y);
            else
                GameConsole.Write("No enemies alive, good job!");
        }

        public static void Write(string txt)
        {
            if (consoleLines.Count > maxConsoleLines)
                consoleLines.RemoveAt(0);

            txt = " " + txt;

            consoleLines.Add(txt);
            //Console.WriteLine(txt);
        }
    }
}
