﻿using System;

namespace CMDSpacePirates {
    public static class Time {

	    private const int fpsTarget = 5;

        public static long ElapsedTime {
            get { return CurrentTime - startTime; }
        }

        private static long CurrentTime {
            get { return DateTime.Now.Ticks; }
        }

        public static long FrameLength {
            get { return (10000000 / fpsTarget); }
        }

        public static long DeltaTime {
			get { return (CurrentTime - timeAtLastFrame); }
        }

        public static long NextFrame {
            get;
            private set;
        }

        private static long startTime;
        private static long timeAtLastFrame;

        public static void UpdateTime() {
            NextFrame += FrameLength;
            timeAtLastFrame = CurrentTime;
        }

        public static void Reset() {
            startTime = DateTime.Now.Ticks;
            timeAtLastFrame = startTime;
        }
    }
}
