﻿using System;
using System.Collections.Generic;

namespace CMDSpacePirates {
	public class GameObject {
		public char[] graphic;
		public int renderPriority; // 0 is first

		public bool firstFrame = true;

		public bool[] collider;

		public Vector size;
		public Vector pos;

		public GameObject(Vector position) {
			Program.addObjQueue.Add(this);
			pos = position;
		}

		public GameObject() {
			Program.addObjQueue.Add(this);
			pos = Vector.Zero;
		}

		//Called in first frame
		public virtual void Start() {
			collider = new bool[graphic.Length];

			for (int i = 0; i < graphic.Length; i++)
				if (graphic[i] != ' ')
					collider[i] = true;
		}

		//Called each frame
		public virtual void Tick() {
			pos.x = (pos.x < 0) ? 1000 + pos.x : pos.x;
			pos.y = (pos.y < 0) ? 1000 + pos.y : pos.y;

			pos.x = (pos.x > 999) ? pos.x - 1000 : pos.x;
			pos.y = (pos.y > 999) ? pos.y - 1000 : pos.y;
		}

		//Called when destroyed
		public virtual void Destroy() { }

		//Called when hit by collision
		public virtual void Hit(int spaceHit) { }
	}
}