﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CMDSpacePirates
{
    public class Projectile : GameObject
    {
        public FloatVector shootDir;
        public FloatVector floatPos;

        private int lifeSpan = 100;
        private int ticks = 0;

        public Projectile(Vector position, FloatVector _dir) : base(position)
        {
            floatPos = new FloatVector(position.x, position.y);
            shootDir = _dir;

            size = new Vector(1, 1);
            graphic = new char[] { '█' };
        }

        public override void Tick()
        {
            base.Tick();
            ticks++;
            if (ticks > lifeSpan)
                Program.Destroy(this);

            floatPos = new FloatVector(floatPos.x + shootDir.x, floatPos.y + shootDir.y);
            pos = Vector.GetIntVector(floatPos);

            GameObject colObj = Program.IsCollision<Player>(pos, false);
            if (colObj != null)
            {
                Program.player.Hit(0);
                graphic = new char[] { ' ' };
                Program.Destroy(this);
            }
        }
    }
}