﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CMDSpacePirates
{
	public static class Render
    {
        public static ConsoleColor renderForegroundColor = ConsoleColor.White;
        public static ConsoleColor renderBackgroundColor = ConsoleColor.Black;

        static char[,] renderGrid;
		public static int renderSizeX, renderSizeY;
		//public static int enemyPanelSizeX;
		public static int enemyBoxHeightY;

        public static bool showGrid = true;

		static int renderToWorldRatio = 4;
		static Vector camPos; // Is updated every frame

		public static void Start()
        {
			renderSizeX = 80;
			renderSizeY = 30;

			//enemyPanelSizeX = 15;
			//enemyBoxHeightY = 8;

            // if windows - comment in
            Console.SetWindowSize((renderSizeX * 2) + 2, renderSizeY + GameConsole.maxConsoleLines + 5);

            renderGrid = new char[renderSizeX + 2, renderSizeY];
		}

		public static void Draw()
        {
            Console.SetCursorPosition(0,0);
			camPos = Program.player.pos;

            // Add spaces
            for (int y = 0; y < renderSizeY; y++)
            {
                for (int x = 0; x < renderSizeX; x++)
                {
                    renderGrid[x, y] = ' ';
                }
            }

            Vector topLeft = WrapPosition( new Vector(camPos.x - renderSizeX / 2, camPos.y + renderSizeY / 2) );
            for (int y = 0; y < renderSizeY; y++)
            {
                for (int x = 0; x < renderSizeX; x++)
                {
                    Vector starPos = WrapPosition(new Vector(topLeft.x + x, topLeft.y - y));
                    renderGrid[x, y] = Program.starmap.graphic[starPos.x, starPos.y];
                }
            }

            // Put objs on render grid relative to cam pos
            Program.gameObjects.Sort((x, y) => x.renderPriority.CompareTo(y.renderPriority));
			foreach (GameObject go in Program.gameObjects)
            {
				Vector relPos = WrapPosition(RelativeTo(go.pos, camPos));
				int g = 0;

				// Test
				if (go.GetType() == typeof(Enemy)){}

				//if (!IsPointInView(go.pos|relPos))
				//    continue;

				for (int y = relPos.y; y < (relPos.y + go.size.y); y++)
                {
					for (int x = relPos.x; x < (relPos.x + go.size.x); x++)
                    {
						if (x < renderSizeX && y < renderSizeY &&
							x > 0 && y > 0)
                        {
							if (go.graphic[g] != ' ')
								renderGrid[x, y] = go.graphic[g];
						}

						g++;
					}
				}
			}

            // Put world coordinates on render grid
            Vector topRight = new Vector(camPos.x + renderSizeX / 2, camPos.y + renderSizeY / 2);
            int r = 0;
            int start = 0;
            char[] posChar = new char[] { '─', 'x', 'x', 'x'};

            //for (int x = 0; x < renderSizeX; x++)
            for (int x = renderSizeX; x >= 0; x--)
            {
                int worldPosX = WrapPosition(new Vector(topRight.x - x, topRight.y)).x+1; //+1 to make it middle

                if (worldPosX % 4 == 0)
                {
                    char[] cArray = worldPosX.ToString("000").ToCharArray();
                    Array.Reverse(cArray);
                    posChar[0] = '─';
                    posChar[1] = cArray[0];
                    posChar[2] = cArray[1];
                    posChar[3] = cArray[2];
                    start = 0;
                }
                else if ((worldPosX + 1) % 4 == 0)
                    start = 1;
                else if ((worldPosX + 2) % 4 == 0)
                {
                    start = 2;
                    if (showGrid)
                    {
                        for (int y = 0; y < renderSizeY; y++)
                        {
                            if (renderGrid[r, y] == '.' || renderGrid[r, y] == ' ')
                                renderGrid[r, y] = '|';
                        }
                    }
                }
                else
                    start = 3;

                renderGrid[r, 0] = posChar[start];
                r++;
            }
            r = 0;
            for (int y = 0; y < renderSizeY; y++)
            {
                int worldPosY = WrapPosition(new Vector(topRight.x, topRight.y - y)).y -2; //-2 to make it middle

                if (worldPosY % 4 == 0)
                {
                    char[] cArray = worldPosY.ToString("000").ToCharArray();
                    posChar[0] = '|';
                    posChar[1] = cArray[0];
                    posChar[2] = cArray[1];
                    posChar[3] = cArray[2];
                    start = 0;
                }
                else if ((worldPosY + 1) % 4 == 0)
                    start = 1;
                else if ((worldPosY + 2) % 4 == 0)
                {
                    start = 2;

                    if (showGrid)
                    {
                        for (int x = 0; x < renderSizeX; x++)
                        {
                            if (renderGrid[x, r] == '.' || renderGrid[x, r] == ' ')
                                renderGrid[x, r] = '-';
                        }
                    }
                }
                else
                    start = 3;

                renderGrid[0, r] = posChar[start];
                r++;
            }

            #region old numbers
            //for (int x = renderSizeX / renderToWorldRatio; x >= 0; x--)
            //{
            //	int worldPosX = WrapPosition(new Vector(topRight.x - renderToWorldRatio * x + renderToWorldRatio / 2, topRight.y)).x;
            //	//worldPosX = (worldPosX < 0) ? 1000 + worldPosX : worldPosX;

            //	char[] posChars = worldPosX.ToString("000").ToCharArray();

            //	renderGrid[r * renderToWorldRatio, 0] = '|';

            //	for (int i = 0; i < renderToWorldRatio - 1; i++)
            //		renderGrid[i + (r * renderToWorldRatio) + 1, 0] = posChars[i];

            //	r++;
            //}
            //for (int y = 0; y < renderSizeY / renderToWorldRatio; y++)
            //         {
            //	int worldPosY = WrapPosition(new Vector(topRight.x, topRight.y - renderToWorldRatio * y)).y - renderToWorldRatio / 2; // -2 to make it middle
            //    //worldPosY = (worldPosY < 0) ? 1000 + worldPosY : worldPosY;

            //	char[] posChars = worldPosY.ToString("000").ToCharArray();

            //	renderGrid[0, y * renderToWorldRatio] = '|';

            //	for (int i = 0; i < renderToWorldRatio - 1; i++)
            //		renderGrid[0, i + (y * renderToWorldRatio) + 1] = posChars[i];
            //}
            #endregion

            // Enemy arrows
            foreach (GameObject go in Program.gameObjects)
            {
                if (go.GetType() == typeof(Enemy))
                {
                    Enemy e = go as Enemy;

                    Vector dif = Vector.DifferenceWrap(new Vector(e.pos.x,Program.player.pos.y), new Vector(Program.player.pos.x, e.pos.y), true);
                    Vector abs = new Vector(Math.Abs(dif.x), Math.Abs(dif.y));
                    Vector dir;

                    int offSet;
                    
                    if (abs.x > abs.y)
                    {
                        dir = Vector.Multiply(Vector.Right, Math.Sign(dif.x), true);
                        offSet = Program.Clamp(dif.y + renderSizeY / 2, 1, renderSizeY-1);
                    }
                    else
                    {
                        dir = Vector.Multiply(Vector.Up, -Math.Sign(dif.y), true);
                        offSet = Program.Clamp(dif.x + renderSizeX / 2, 1, renderSizeX-1);
                    }

                    // dir = side in render window
                    // offset = where in x/y respectively

                    Vector top = new Vector(offSet, 1);
                    Vector bot = new Vector(offSet, renderSizeY-1);
                    Vector rgt = new Vector(renderSizeX-1, offSet);
                    Vector lft = new Vector(1, offSet);

                    if (dir.x == Vector.Up.x && dir.y == Vector.Up.y)
                        DrawArrow(top, 'A');
                    if (dir.x == -Vector.Up.x && dir.y == -Vector.Up.y)
                        DrawArrow(bot, 'V');
                    if (dir.x == Vector.Right.x && dir.y == Vector.Right.y)
                        DrawArrow(rgt, '>');
                    if (dir.x == -Vector.Right.x && dir.y == -Vector.Right.y)
                        DrawArrow(lft, '<');
                }
            }


            // Enemy panel
            #region Enemy panel
            /*
            List<Enemy> enemies = new List<Enemy>();
			foreach (GameObject go in Program.gameObjects)
            {
				if (go.GetType() == typeof(Enemy))
                {
					enemies.Add(go as Enemy);
				}
			}
			if (enemies.Count > 0)
            {
				int g = 0;
				int e = 1;
				Enemy curEnemy = enemies[0];
				for (int y = 0; y < enemies.Count; y++)
                {
					int ePaddingX = (enemyPanelSizeX - curEnemy.size.x) / 2 - 1;
					int ePaddingY = 1;

					for (int by = ePaddingY; by < enemyBoxHeightY - ePaddingY; by++)
                    {
						for (int x = ePaddingX; x < enemyPanelSizeX; x++)
                        {
							if (x >= curEnemy.size.x + ePaddingX)
								continue;

							// It's hella ugly I know. Sry.
							if (g >= curEnemy.graphic.Length)
                            {
								// Write pos & dir
								by += enemyBoxHeightY * y + 1;
								// testies (wait what)
								char[] ePosX = (WrapPosition(curEnemy.pos).x).ToString().ToCharArray();
								char[] ePosY = (WrapPosition(curEnemy.pos).y).ToString().ToCharArray();

                                if (ePosX.Length > 3)
                                    ePosX = new char[] { 'x', 'x', 'x' };
                                if (ePosY.Length > 3)
                                    ePosY = new char[] { 'x', 'x', 'x' };

                                renderGrid[x + renderSizeX + 0, by] = 'p';
								renderGrid[x + renderSizeX + 1, by] = 'o';
								renderGrid[x + renderSizeX + 2, by] = 's';
								renderGrid[x + renderSizeX + 3, by] = ':';

								int xAdd = 4;

								for (int i = 0; i < ePosX.Length; i++)
                                {
									renderGrid[x + renderSizeX + xAdd, by] = ePosX[i];
									xAdd++;
								}
								renderGrid[x + renderSizeX + xAdd, by] = ',';
								xAdd++;
								for (int i = 0; i < ePosY.Length; i++)
                                {
									renderGrid[x + renderSizeX + xAdd, by] = ePosY[i];
									xAdd++;
								}

								by += 1;

								char[] eDirX = (curEnemy.dir.x * curEnemy.engines.Count).ToString().ToCharArray();
								char[] eDirY = (curEnemy.dir.y * curEnemy.engines.Count).ToString().ToCharArray();

								renderGrid[x + renderSizeX + 0, by] = 'd';
								renderGrid[x + renderSizeX + 1, by] = 'i';
								renderGrid[x + renderSizeX + 2, by] = 'r';
								renderGrid[x + renderSizeX + 3, by] = ':';

								xAdd = 4;

								for (int i = 0; i < eDirX.Length; i++)
                                {
									renderGrid[x + renderSizeX + xAdd, by] = eDirX[i];
									xAdd++;
								}
								renderGrid[x + renderSizeX + xAdd, by] = ',';
								xAdd++;
								for (int i = 0; i < eDirY.Length; i++)
                                {
									renderGrid[x + renderSizeX + xAdd, by] = eDirY[i];
									xAdd++;
								}

								by += enemyBoxHeightY; // To break out of box loop aswell
								break;
							}

							renderGrid[x + renderSizeX, by + enemyBoxHeightY * y] = curEnemy.graphic[g];
							g++;
						}
					}

					if (e >= enemies.Count)
						break;

					curEnemy = enemies[e];
					e++;
					g = 0;

                    if (e > 3)
                        break;
				}
			}
            */
            #endregion
            
            // Draw chars to screen
            string frame = "";
			for (int y = 0; y < renderSizeY; y++)
            {
				// for (int x = renderSizeX + enemyPanelSizeX - 1; x >= 0; x--) Invert row (fucks shit up)
				for (int x = 0; x < renderSizeX; x++)
                {
					frame += " " + renderGrid[x, y];
					//Console.Write(" " + renderGrid[x, y]);
				}
				frame += "\n";
				//Console.Write("\n");
			}
            Console.ForegroundColor = renderForegroundColor;
            Console.BackgroundColor = renderBackgroundColor;

            Console.WriteLine(frame);
            
            renderForegroundColor = ConsoleColor.White;
            renderBackgroundColor = ConsoleColor.Black;

            // Redraw the console
            GameConsole.RenderConsole();
		}

        static void DrawArrow(Vector position, char character)
        {
             renderGrid[position.x, position.y] = character;
        }

		static Vector RelativeTo(Vector pos, Vector target)
        {
			//return new Vector((target.x + pos.x) - renderSizeX / 2, (target.y + pos.y) - renderSizeY / 2);
			return new Vector((renderSizeX / 2) - (target.x - pos.x), target.y - pos.y + renderSizeY / 2);

			// Turning '-' into '+'   \/   is interesting. Maybe you could do some math abs difference stuff. What is relative pos?
			//return new Vector(target.x - pos.x + renderSizeX / 2, target.y - pos.y + renderSizeY / 2);
			//return new Vector(target.x + Math.Abs(target.x - pos.x), target.y + Math.Abs(target.y - pos.y));
		}

        public static int WrapInt(int i)
        {
            i = (i < 0) ? 1000 + i : i;
            i = (i > 999) ? i - 1000 : i;
            return i;
        }

	    public static Vector WrapPosition(Vector pos)
        {
			pos.x = (pos.x < 0) ? 1000 + pos.x : pos.x;
			pos.y = (pos.y < 0) ? 1000 + pos.y : pos.y;

			pos.x = (pos.x > 999) ? pos.x - 1000 : pos.x;
			pos.y = (pos.y > 999) ? pos.y - 1000 : pos.y;

			//pos.x = (pos.x < 0) ? 999 + pos.x : pos.x;
			//pos.y = (pos.y < 0) ? 999 + pos.x : pos.y;

			//pos.x = (pos.x > 999) ? pos.x - 999 : pos.x;
			//pos.y = (pos.y > 999) ? pos.y - 999 : pos.y;

			return pos;
		}

		public static bool IsPointInView(Vector point)
        {
			Vector maxPos = WrapPosition(new Vector(camPos.x + renderSizeX / 2 + 1, camPos.y + renderSizeY / 2 + 1));
			Vector minPos = WrapPosition(new Vector(camPos.x - renderSizeX / 2 - 1, camPos.y - renderSizeY / 2 - 1));

			return
			(point.x < camPos.x + renderSizeX / 2 + 1 || point.x < maxPos.x) &&
			(point.y < camPos.y + renderSizeY / 2 + 1 || point.y < maxPos.y) &&
			(point.x > camPos.x - renderSizeX / 2 - 1 || point.x > minPos.x) &&
			(point.y > camPos.y - renderSizeX / 2 - 1 || point.y > minPos.y);
		}
	}
}
