﻿using System;
using System.IO;

namespace CMDSpacePirates
{
    class SoundCreator
    {
        static int RIFF = 0x46464952;
        static int WAVE = 0x45564157;
        static int formatChunkSize = 16;
        static int headerSize = 8;
        static int format = 0x20746D66;
        static short formatType = 1;
        static short tracks = 1;
        static int samplesPerSecond = 44100;
        static short bitsPerSample = 16;
        static int data = 0x61746164;

        static int samples;
        static short frameSize;
        static int bytesPerSecond;
        static int fileSize;
        static int dataChunkSize;

        static double ampl = 10000;
        static double perfect = 1.5;
        //static double concert = 1.498307077;

        public static string premadeSound = "";


        public static void SetupSound()
        {
            frameSize = (short)(tracks * ((bitsPerSample + 7) / 8));
            bytesPerSecond = samplesPerSecond * frameSize;
            /*premadeSound += RIFF.ToString();
			premadeSound += fileSize.ToString();
			premadeSound += WAVE.ToString();
			premadeSound += format.ToString();
			premadeSound += formatChunkSize.ToString();
			premadeSound += formatType.ToString();
			premadeSound += tracks.ToString();
			premadeSound += samplesPerSecond.ToString();
			premadeSound += bytesPerSecond.ToString();
			premadeSound += frameSize.ToString();
			premadeSound += bitsPerSample.ToString();
			premadeSound += data.ToString();
			premadeSound += dataChunkSize.ToString();*/
        }


        public static void MakeSound(string name, double freq = 8000.0, double duration = 10)
        {
            FileStream stream = new FileStream(name + ".wav", FileMode.Create);
            BinaryWriter writer = new BinaryWriter(stream);

            samples = (int)(duration * samplesPerSecond);

            dataChunkSize = samples * frameSize;
            fileSize = headerSize + formatChunkSize + headerSize + dataChunkSize;

            //string newSound = premadeSound;
            writer.Write(RIFF);
            writer.Write(fileSize);
            writer.Write(WAVE);
            writer.Write(format);
            writer.Write(formatChunkSize);
            writer.Write(formatType);
            writer.Write(tracks);
            writer.Write(samplesPerSecond);
            writer.Write(bytesPerSecond);
            writer.Write(frameSize);
            writer.Write(bitsPerSample);
            writer.Write(data);
            writer.Write(dataChunkSize);
            writer.Write(premadeSound);
            double aNatural = freq;

            double _freq = aNatural * perfect;

            for (int i = 0; i < samples; i++)
            {
                double t = (double)i / (double)samplesPerSecond;
                short s = (short)(ampl * (Math.Sin(t * _freq * 2.0 * Math.PI)));
                writer.Write(s);
            }
            //return newSound;
            writer.Close();
            stream.Close();
        }
    }
}